import bpy, os

from ..constants import photographer_folder

def append_mesh(mesh_name, keep_dimensions=True):
    object = None
    path = "blends/meshes.blend/Mesh/"

    dir = os.path.join(photographer_folder,path)

    # Normalize slashes for Windows // linux
    dir = os.path.normpath(dir)

    mesh = None
    meshes = [m for m in bpy.data.meshes if m.name == mesh_name]
    if meshes:
        mesh = meshes[0]

    # Append mesh if it doesn't already exist
    if not mesh:
        bpy.ops.wm.append(filename=mesh_name, directory=dir, do_reuse_local_id=True)
        mesh = [m for m in bpy.data.meshes if m.name == mesh_name][0]
        object = [o for o in bpy.data.objects if o.data is mesh][0]
        if keep_dimensions:
            object.scale /= bpy.context.scene.unit_settings.scale_length
        
    return mesh, object